
Robotics Service Bus - Bug #484
Converters for Fundamental Types are not Implemented [C++]
08/08/2011 03:58 AM - J. Moringen

Status: Resolved Start date: 08/08/2011
Priority: Normal Due date:
Assignee: J. Moringen % Done: 100%
Category: C++ Estimated time: 0.00 hour
Target version: rsb-0.15
Description

Despite what [[Types|this]] description suggests.

Seemingly most important: double (see #606).

Progress:

Wire Schema String Designator Converter
No value "void" rsb::converter::VoidConverter
Double precision float "double" rsb::converter::FloatingPointCo

nverter<double>
Single precision float "float" rsb::converter::FloatingPointCo

nverter<float>
32 bit signed integer "int32" rsb::converter::IntegerConvert

er<int32_t>
64 bit signed integer "int64" rsb::converter::IntegerConvert

er<int64_t>
32 bit unsigned integer "uint32" rsb::converter::IntegerConvert

er<uint32_t>
64 bit unsigned integer "uint64" rsb::converter::IntegerConvert

er<uint64_t>
bool "bool" rsb::converter::BoolConverter
ASCII string "ascii-string"
UTF-8 string "utf-8-string" rsb::converter::StringConverte

r
Sequence of bytes "bytes" rsb::converter::ByteArrayConv

erter
Scope "scope" rsb::converter::ScopeConverte

r
Event ID ".rsb.protocol.EventId" rsb::converter::EventIdConver

ter

Associated revisions
Revision b27ed22f - 01/21/2013 07:38 PM - J. Moringen

Changed bool encoding in src/rsb/converter/BoolConverter.cpp

refs #484

    -  src/rsb/converter/BoolConverter.cpp (header): updated copyright
  (BoolConverter::serialize): store either 0 or 1
  (BoolConverter::deserialize): expected either 0 or 1
    -  test/rsb/converter/DefaultConverterTest.cpp: cosmetic changes

Revision ebf823b0 - 03/08/2013 01:07 PM - J. Wienke

Backport: Add a converter for unit32.

refs #484

Revision 3dcfcf4a - 07/31/2013 02:57 PM - J. Wienke

Added Int64converter.

refs #484

Revision b8090c7b - 06/03/2016 11:59 AM - J. Moringen

Mention C++ float and double converters in news.rst

refs #484

    -  news.rst (RSB 0.14): mention new float and double converters that have
  been added to the C++ implementation

Revision d72d6440 - 06/03/2016 12:04 PM - J. Moringen

Added double, float converter in src/rsb/converter/FloatConverter.{h,cpp}

refs #484

The new template class FloatConverter converts floating point values by
just grabbing the bit pattern from memory. To make this at least
slightly safe, a runtime_error is throw in the constructor unless

std::numeric_limits&lt;T&gt;::is_iec559

is true.

    -  src/rsb/converter/FloatConverter.{h,cpp}: new files; contain
  implementation FloatConverter template class with specializations for
  float and double

    -  src/rsb/converter/converters.cpp (registerDefaultConverters): register
  FloatConverter<float> and FloatConverter<double>

    -  test/rsb/converter/DefaultConverterTest.cpp (header): updated copyright
  (FloatConverterTest): new test; roundtrip test for
  FloatConverter<float>
  (DoubleConverterTest): new test; roundtrip test for
  FloatConverter<double>

    -  src/CMakeLists.txt: added files
  src/rsb/converter/FloatConverter.{h,cpp}
Revision 178f08b5 - 06/03/2016 01:10 PM - J. Moringen

Floating point converters in src/rsb/converter/FloatingPointConverter.{h,cpp}

refs #484

The new template class FloatingPointConverter converts floating point
values by just grabbing the bit pattern from memory. To make this at
least slightly safe, a runtime_error is throw in the constructor unless

std::numeric_limits&lt;T&gt;::is_iec559

is true. Derived classes FloatConverter and DoubleConverter are provided
for convenience.

    -  src/rsb/converter/FloatingPointConverter.{h,cpp}: new files; contain
  FloatingPointConverter template class with specializations
  FloatConverter and DoubleConverter for float and double respectively

    -  src/rsb/converter/converters.cpp (registerDefaultConverters): register
  FloatConverter and DoubleConverter

    -  test/rsb/converter/DefaultConverterTest.cpp (header): updated copyright
  (FloatConverterTest): new test; roundtrip test for FloatConverter
  (DoubleConverterTest): new test; roundtrip test for DoubleConverter

    -  src/CMakeLists.txt: added files
  src/rsb/converter/FloatingPointConverter.{h,cpp}

Revision 9aa1f5c4 - 06/03/2016 01:12 PM - J. Moringen

Backport: Floating point converters in src/rsb/converter/FloatingPointConverter.{h,cpp}

refs #484

The new template class FloatingPointConverter converts floating point
values by just grabbing the bit pattern from memory. To make this at
least slightly safe, a runtime_error is throw in the constructor unless

std::numeric_limits&lt;T&gt;::is_iec559

is true. Derived classes FloatConverter and DoubleConverter are provided
for convenience.

    -  src/rsb/converter/FloatingPointConverter.{h,cpp}: new files; contain
  FloatingPointConverter template class with specializations
  FloatConverter and DoubleConverter for float and double respectively

    -  src/rsb/converter/converters.cpp (registerDefaultConverters): register
  FloatConverter and DoubleConverter

    -  test/rsb/converter/DefaultConverterTest.cpp (header): updated copyright
  (FloatConverterTest): new test; roundtrip test for FloatConverter
  (DoubleConverterTest): new test; roundtrip test for DoubleConverter

    -  src/CMakeLists.txt: added files
  src/rsb/converter/FloatingPointConverter.{h,cpp}

(cherry picked from commit 178f08b5819ff5f7969f7ad12bdd599d67abe78d)
Revision f0667f10 - 06/16/2016 02:22 PM - J. Moringen

Added generic IntegerConverter in src/rsb/converter/IntegerConverter.{h,cpp}

refs #484

    -  src/rsb/converter/{Int64,Uint32,Uint64}Converter.{h,cpp}: removed; no
  longer needed

    -  src/rsb/converter/IntegerConverter.{h,cpp}: new files; interface and
  implementation of generic integer converter

    -  src/rsb/converter/converters.cpp: adjusted includes
    -  test/rsb/converter/DefaultConverterTest.cpp: likewise
    -  src/CMakeLists.txt: removed files

  src/rsb/converter/{Int64,Uint32,Uint64}Converter.{h,cpp}; added files
  src/rsb/converter/IntegerConverter.{h,cpp}

Revision 08cdd6b4 - 06/16/2016 03:10 PM - J. Moringen

Added generic IntegerConverter in src/rsb/converter/IntegerConverter.{h,cpp}

refs #484

    -  src/rsb/converter/{Int64,Uint32,Uint64}Converter.{h,cpp}: removed; no
  longer needed

    -  src/rsb/converter/IntegerConverter.{h,cpp}: new files; interface and
  implementation of generic integer converter

    -  src/rsb/converter/converters.cpp: adjusted includes
    -  test/rsb/converter/DefaultConverterTest.cpp: likewise
    -  src/CMakeLists.txt: removed files

  src/rsb/converter/{Int64,Uint32,Uint64}Converter.{h,cpp}; added files
  src/rsb/converter/IntegerConverter.{h,cpp}

Revision 8c26dc79 - 06/16/2016 03:51 PM - J. Moringen

Added ScopeConverter class in src/rsb/converter/ScopeConverter.{h,cpp}

fixes #484

    -  src/rsb/converter/ScopeConverter.{h,cpp}: new file; interface and
  implementation of ScopeConverter class

    -  src/rsb/converter/converters.cpp (registerDefaultConverters): register
  ScopeConverter

    -  test/rsb/converter/DefaultConverterTest.cpp (ScopeConverterTest): new
  test; for ScopeConverter class

    -  src/CMakeLists.txt: added files
  src/rsb/converter/ScopeConverter.{h,cpp}

Revision 9e228d39 - 06/16/2016 05:30 PM - J. Moringen

Mention new C++ IntegerConverter in news.rst
refs #484

    -  news.rst (RSB 0.15): mention new C++ IntegerConverter

Revision 3eaefa9f - 06/16/2016 05:32 PM - J. Moringen

Mention new C++ ScopeConverter in news.rst

refs #484

    -  news.rst (RSB 0.15): mention new C++ ScopeConverter

History
#1 - 10/04/2011 03:33 PM - J. Moringen
- Priority changed from Normal to High

#2 - 10/04/2011 03:34 PM - J. Moringen
- Description updated

#3 - 01/21/2013 08:11 PM - J. Moringen
- % Done changed from 0 to 50

#4 - 12/10/2013 11:47 PM - J. Moringen
- Target version changed from rsb-0.10 to rsb-0.11

#5 - 11/27/2014 01:20 PM - S. Wrede
- Priority changed from High to Normal

#6 - 12/17/2014 10:44 AM - J. Wienke
- Target version changed from rsb-0.11 to rsb-0.12

#7 - 03/25/2015 11:36 AM - J. Moringen
- Status changed from New to In Progress

#8 - 04/27/2015 11:14 AM - J. Wienke
- Target version changed from rsb-0.12 to rsb-0.13

#9 - 03/02/2016 08:55 AM - J. Moringen
- Target version changed from rsb-0.13 to rsb-0.14

#10 - 05/13/2016 01:58 PM - J. Moringen
- Target version changed from rsb-0.14 to rsb-0.15

#11 - 06/03/2016 01:13 PM - J. Moringen
- % Done changed from 50 to 80

#12 - 06/11/2016 03:42 PM - J. Moringen
- Description updated
- Assignee set to J. Moringen

#13 - 06/11/2016 03:46 PM - J. Moringen
- Description updated

#14 - 06/11/2016 03:57 PM - J. Moringen
- Description updated

#15 - 06/16/2016 01:53 PM - J. Moringen
- Subject changed from Converters for Fundamental Types are not Implemented to Converters for Fundamental Types are not Implemented [C++]

#16 - 06/16/2016 02:23 PM - J. Moringen
- Description updated
- % Done changed from 80 to 90

#17 - 06/16/2016 04:00 PM - J. Moringen
- Status changed from In Progress to Resolved
- % Done changed from 90 to 100

Applied in changeset commit:rsb-cpp|8c26dc79997d4d0339e6dc0ece5fecfa304dfd36.

#18 - 06/16/2016 05:27 PM - J. Moringen
- Description updated
